;this demo illustrates motion blur and texture scrolling
;it can be made faster if we put all the time-invariant things into display lists,
;rebuilding them whenever the host window gets resized (auto_scale 0)

;a temporary alias for simplifying nLIGHTn calls
alias gl { var %c = $dll(nLIGHTn,gl,$1-) | if (E_* iswm %c) echo -a $1- : %c | return %c }

;this alias convert textures from .jpg to .bmp format
alias -l jpg2bmp {
  window -hpf @jpg2bmp1 0 0 512 256
  drawpic @jpg2bmp1 0 0 $+(",$scriptdirearth.jpg,") | drawsave -b24 @jpg2bmp1 $+(",$scriptdirearth.bmp,")
  close -@ @jpg2bmp1
}

;call this alias to see the demo
alias gldemo {
  clear
  ;first of all, we create a picture window (any HWND will do)
  window -p @test 0 0 512 256
  window -r @test
  titlebar @test - Press any key to switch the sky on/off

  ;attach a rendering device to the window and make it current
  gl attach $window(@test).hwnd

  ;set up various things
  gl enable color_material
  gl blend_func src_alpha one_minus_src_alpha
  gl light light0 position 0 1 0 0
  gl light light0 ambient 0.5 0.5 0.5

  ;load textures
  if !$isfile($+(",$scriptdirearth.bmp,")) { jpg2bmp }
  gl bind_texture 1 | gl load_texture $scriptdirearth.bmp 
  gl bind_texture 2 | gl load_texture $scriptdirskyhorz.bmp
  gl tex_parameter texture_2d texture_min_filter linear_mipmap_nearest

  ;initial list
  gl new_list 10000
  gl clear
  gl matrix_mode modelview
  gl load_identity
  gl matrix_mode texture
  gl load_identity
  gl matrix_mode projection
  gl push_matrix
  gl load_identity
  gl enable texture_2d
  gl bind_texture 2
  gl end_list 10000

  ;before drawing earth
  gl new_list 10010
  gl load_identity
  gl matrix_mode projection 
  gl pop_matrix
  gl matrix_mode modelview
  gl look_at 0 0 5 0 0 0 0 1 0
  gl push_matrix
  gl end_list 10010

  ;the earth
  gl new_list 10020
  gl rotate -90 1 0 0
  gl bind_texture 1
  gl sphere 1 20 20 0 0 0 1
  gl pop_matrix
  gl end_list 10020

  ;the sputniks
  gl new_list 10030
  gl enable blend
  gl enable lighting
  gl disable texture_2d
  var %c = 1 | while %c <= 7 {
    gl push_matrix
    gl rotate %c 0 1 0
    gl translate 2.5 0 0
    gl color 1 1 1 $calc(%c * 0.1)
    gl sphere 0.06 4 2
    gl pop_matrix
    inc %c
  }
  gl disable blend
  gl rotate 6 0 1 0
  gl translate 2.5 0 0
  gl color 1 1 1 1
  gl sphere 0.06 4 2
  gl disable lighting
  gl color 1 1 1 1
  gl end_list 10030

  set %gl_sky 1
  ;we have all we need. start rendering
  .timergl -m 0 1 motion_blur attach $window(@test).hwnd $!window(@test).dw $!window(@test).dh
}

alias motion_blur {
  dll nLIGHTn gl $1-2
  dll nLIGHTn gl call_list 10000
  dll nLIGHTn gl ortho 0 $3-4 0 -1 0.1
  dll nLIGHTn gl matrix_mode texture
  dll nLIGHTn gl translate $calc(-0.00005 * $ticks) 0 0
  if %gl_sky {
    dll nLIGHTn gl begin quads
    dll nLIGHTn gl tex_coord 0 1 | dll nLIGHTn gl vertex 0 0 
    dll nLIGHTn gl tex_coord 0 0 | dll nLIGHTn gl vertex 0 $4
    dll nLIGHTn gl tex_coord 1 0 | dll nLIGHTn gl vertex $3 $4
    dll nLIGHTn gl tex_coord 1 1 | dll nLIGHTn gl vertex $3 0
    dll nLIGHTn gl end
  }

  dll nLIGHTn gl call_list 10010
  var %d = $calc($ticks / 20)
  dll nLIGHTn gl rotate %d 0 1 0
  dll nLIGHTn gl call_list 10020

  dll nLIGHTn gl push_matrix
  dll nLIGHTn gl rotate 150 1 0 0
  dll nLIGHTn gl rotate %d 0 1 0
  dll nLIGHTn gl call_list 10030
  dll nLIGHTn gl pop_matrix

  dll nLIGHTn gl push_matrix
  dll nLIGHTn gl rotate 90 %c 1 0 0
  dll nLIGHTn gl rotate $calc(240 + %d) 0 1 0
  dll nLIGHTn gl call_list 10030
  dll nLIGHTn gl pop_matrix

  dll nLIGHTn gl rotate 30 1 0 0
  dll nLIGHTn gl rotate $calc(120 + %d) 0 1 0
  dll nLIGHTn gl call_list 10030
  dll nLIGHTn gl swap_buffers
}

;when you close the window, the timer should stop
on ^*:CLOSE:@test: .timergl off

;toggle texture upon keypress
on *:KEYDOWN:@test:*: %gl_sky = $iif(%gl_sky,0,1)

;cleanup
on *:UNLOAD: {
  unset %gl*
  .remove $+(",$scriptdirearth.bmp,")
}
