;this demo illustrates motion point lights and some glu figures

;a temporary alias for simplifying nLIGHTn calls
alias gl { var %c = $dll(nLIGHTn,gl,$1-) | if (E_* iswm %c) echo -a $1- : %c | return %c }

;call this alias to see the demo
alias gldemo {
  clear

  ;first of all, we create a picture window (any HWND will do) 
  ;and attach a rendering device to the window and make it current
  window -p @test
  gl attach $window(@test).hwnd

  ;you can uncomment this
  ;gl polygon_mode front_and_back line

  ;we'll have 3 lights, light0 is enabled by default
  gl enable lighting
  gl light light0 ambient 0.3 0.3 0.3 0
  gl light light0 diffuse 0.8 0.8 0.8 0
  gl enable light1
  gl light light1 ambient 0.3 0.3 0.3 0
  gl light light1 diffuse 0.8 0.8 0.8 0
  gl enable light2
  gl light light2 ambient 0.3 0.3 0.3 0
  gl light light2 diffuse 0.8 0.8 0.8 0

  ;create the left plane
  ;lighting calculations are performed per vertex, so 1 quad isn't enough

  gl new_list 10000
  gl normal 1 0 0

  ;note that quad strips would be more efficient in our case... but oh well
  gl begin quads

  var %cnt = 10, %d = $calc(2 / %cnt)
  var %i = $calc(%cnt - 1) | while %i >= 0 {
    var %j = $calc(%cnt - 1) | while %j >= 0 {
      var %x0 = %i * %d, %y0 = %j * %d, %x1 = $calc(%x0 + %d), %y1 = $calc(%y0 + %d)
      gl vertex -1 $calc(-1 + %x0) $calc(-1 + %y0)
      gl vertex -1 $calc(-1 + %x1) $calc(-1 + %y0)
      gl vertex -1 $calc(-1 + %x1) $calc(-1 + %y1)
      gl vertex -1 $calc(-1 + %x0) $calc(-1 + %y1)
      dec %j
    }
    dec %i
  }
  gl end  
  gl end_list

  ;we need 3 such planes
  gl new_list 10001
  gl enable cull_face
  gl clear
  gl load_identity
  gl look_at 3 1 5 0 0 0 0 1 0
  gl material front_and_back ambient_and_diffuse 0.2 0.2 0.2 0
  gl push_matrix
  gl call_list 10000
  gl rotate -90 0 1 0
  gl call_list 10000
  gl rotate 90 0 0 1
  gl call_list 10000
  gl pop_matrix
  gl end_list

  ;flying cone
  gl new_list 10002
  gl material front_and_back ambient_and_diffuse 1 1 0 0
  gl disable cull_face
  gl cylinder 0.1 0 0.1 10 10
  gl end_list  

  ;flying sphere
  gl new_list 10003
  gl sphere 0.1 20 20
  gl end_list  

  ;flying cylinder
  gl new_list 10004
  ;gl sphere 0.1 20 20
  gl cylinder 0.1 0.1 0.1 10 10
  gl end_list  

  ;we have all we need, start rendering
  .timergl -m 0 10 gl_paint gl attach $window(@test).hwnd
}

;this is where we construct every frame
;we don't use the 'gl' alias, as it slows mIRC down

alias gl_paint {
  dll nLIGHTn $1-
  dll nLIGHTn gl call_list 10001

  var %d = $calc($ticks / 500)
  dll nLIGHTn gl push_matrix
  dll nLIGHTn gl rotate 90 $sin(%d) $cos(%d)
  dll nLIGHTn gl translate $calc(0.9 * $cos(%d)) $calc(0.9 * $sin(%d)) 0
  dll nLIGHTn gl light light0 position 0 0 0 1
  dll nLIGHTn gl call_list 10002

  inc %d 0.4
  dll nLIGHTn gl pop_matrix
  dll nLIGHTn gl push_matrix
  dll nLIGHTn gl rotate 90 $sin(%d) $cos(%d)
  dll nLIGHTn gl translate $calc(0.9 * $cos(%d)) $calc(0.9 * $sin(%d)) 0
  dll nLIGHTn gl light light1 position 0 0 0 1
  dll nLIGHTn gl call_list 10003

  inc %d 0.4
  dll nLIGHTn gl pop_matrix
  dll nLIGHTn gl rotate 90 $sin(%d) $cos(%d)
  dll nLIGHTn gl translate $calc(0.9 * $cos(%d)) $calc(0.9 * $sin(%d)) 0
  dll nLIGHTn gl light light2 position 0 0 0 1
  dll nLIGHTn gl call_list 10004

  dll nLIGHTn gl swap_buffers
}

;when you close the window, the timer should stop
on ^*:CLOSE:@test: .timergl off
