//----------------------------------------------------------------------------
#define mb(x) MessageBox(0,x,0,0)
#include "BMPLoader.h"
#pragma warning(disable : 4786)
#include <map>
#include "Constants.hpp"
#include "GL.hpp"

//----------------------------------------------------------------------------
extern "C" void __stdcall LoadDll(LPVOID p_li) { }
extern "C" int __stdcall UnloadDll(int timeout) { return 0; }
#define ret(x) return(strcpy(output,x),3)

//------------------------------------------------------------------------------------//
void scale_window()
{
	RECT rect;
	GetClientRect(pdev->hwnd,&rect);
	int width = rect.right, height = rect.bottom ? rect.bottom : 1;
	wglMakeCurrent(pdev->dc,pdev->rc);
	glViewport(0,0,width,height);				
	glPushAttrib(GL_TRANSFORM_BIT);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(pdev->as_angle,(pdev->as_mode == 1 ? double(width)/height : 1),pdev->as_min,pdev->as_max);
	glPopAttrib();
}

//------------------------------------------------------------------------------------//
//subclass window procedure
LRESULT CALLBACK subclass_wnd_proc(HWND hwnd,UINT msg,WPARAM wp,LPARAM lp)
{
	pdev = &(devices.find(hwnd)->second);
	WNDPROC old_proc = pdev->old_wnd_proc;
	switch(msg)
	{
	case WM_SIZE:
		switch(pdev->as_mode)
		{
		case 1: case 2:
			if (pdev->as_angle && pdev->as_min && pdev->as_max) scale_window();
			break;
		default: pdev->was_resized = true;
		}
		break;
		case WM_ERASEBKGND: return 0;
		case WM_PAINT:
			ValidateRect(hwnd,0);
			return 0;
		case WM_DESTROY:
			devices.erase(hwnd);
			break;
	}
	
	return CallWindowProc(old_proc,hwnd,msg,wp,lp);
}

//------------------------------------------------------------------------------------//
extern "C" int __stdcall gl(HWND mWnd,HWND,char*data,char*,BOOL show,BOOL)
{
	input = output = data;
	
	//hash first tokens
	int cmd_hash = hash_token();
	
	//special commands
	switch((UINT)cmd_hash)
	{
	case 2470634953: //version
		ret("nLIGHTn beta2 by Necroman, #mIRC @ Undernet");
	case 2627297988: //attach
		{
			HWND window = (HWND)(int)token(), share = (HWND)(int)token();
			std::map<HWND,Device>::iterator i = devices.find(window);
			std::map<HWND,Device>::iterator is = devices.find(share);
			
			//select existing dev
			if (i != devices.end())
			{			
				sel_wnd = window;
				pdev = &(i->second);
				wglMakeCurrent(pdev->dc,pdev->rc);
				
				//notify of new size
				if (pdev->was_resized)
				{
					RECT rect;
					GetClientRect(window,&rect);
					int width = rect.right;
					int height = rect.bottom;
					if (!height) height = 1;
					pdev->was_resized = false;
					sprintf(output,"/.signal -n nLIGHTn %d SIZE %d %d",window, width, height);
					return 2;
				}
				glMatrixMode(GL_MODELVIEW);
				glLoadIdentity();
				ret("S_OK");
			}
			
			//create new dev
			if (!IsWindow(window)) ret("E_INVALID_WINDOW");
			HDC dc = GetDC(window);

			PIXELFORMATDESCRIPTOR pfd; 
			ZeroMemory(&pfd,sizeof(pfd));
			pfd.nSize = sizeof(pfd);
			pfd.nVersion = 1;
			pfd.dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER | PFD_GENERIC_ACCELERATED; 
			pfd.dwLayerMask = PFD_MAIN_PLANE;
			pfd.iPixelType = PFD_TYPE_RGBA;
			pfd.cColorBits = 32;
			pfd.cDepthBits = 32;
			if (!SetPixelFormat(dc, ChoosePixelFormat(dc, &pfd), &pfd))
			{
				ReleaseDC(window,dc);
				ret("E_INCOMPATIBLE_PIXEL_FORMAT");
			}
			
			HGLRC rc = wglCreateContext(dc);
			if (!rc) { ReleaseDC(window,dc); ret("E_FAILED"); }
			
			//rendering context created successfully
			pdev = &devices[window];
			pdev->old_wnd_proc = (WNDPROC)SetWindowLong(window,GWL_WNDPROC,(LONG)subclass_wnd_proc);
			pdev->dc = dc;
			pdev->rc = rc;
			pdev->hwnd = window;
			sel_wnd = window;
			wglMakeCurrent(dc,rc);
			if (is != devices.end())	//share display lists and fonts
			{
				if (!wglShareLists(is->second.rc,rc))
				{
					int error = GetLastError();
					ret("E_CANNOT_SHARE_DISPLAY_LISTS");
				}
				pdev->fonts = is->second.fonts;
				pdev->sel_font = is->second.sel_font;
			}
			
			//initial OpenGL setup
			glClearColor(0,0,0,0);
			glEnable(GL_DEPTH_TEST);
			glEnable(GL_LIGHT0);
			float full[] = { 0, 0, 0, 1 };
			glLightfv(GL_LIGHT0,GL_AMBIENT,full);
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			scale_window();
			
			//hide static child
			HWND damned_child = FindWindowEx(window,0,"mIRC_Status","");
			if (damned_child) ShowWindow(damned_child,SW_HIDE);
			else
			{
				damned_child = FindWindowEx(window,0,"Static","");
				if (damned_child) ShowWindow(damned_child,SW_HIDE);
			}
			ret("S_OK");
		}
	}
	
	//get function address
	int *cmd_adr;
	
	if (!(cmd_adr = (int*)bsearch(&cmd_hash,cmd_hashes,sizeof(cmd_hashes)/sizeof(int),
		sizeof(int),(int (__cdecl *)(const void*,const void*))compare_hashes)))
		ret("E_NOT_IMPLEMENTED");
	
	void (*p)() = cmd_adrs[cmd_adr - cmd_hashes];
	
	//ensure valid attached dev
	std::map<HWND,Device>::iterator i = devices.find(sel_wnd);
	if (i == devices.end()) ret("E_INVALID_WINDOW");
	pdev = &(i->second);
	
	//invoke function
	*data = 0;
	try { p(); }
	catch(const char *error) { strcpy(data,error); }
    if (!*data) strcpy(data,"S_OK");
	return 3;
}